function [X,ShowFaces,Elist, e2t, t2e, InnerEdges] = read_off_general(filename)

fid = fopen(filename,'r');
if( fid==-1 )
    error('Cannot open the file.');
    return;
end

str = fgets(fid);   % -1 if eof
if ~strcmp(str(1:3), 'OFF')
    error('The file is not a valid OFF one.');    
end

str = fgets(fid);
sizes = sscanf(str, '%d %d', 2);
nv = sizes(1);
nf = sizes(2);

% Read vertices
[X,cnt] = fscanf(fid,'%lf %lf %lf\n', [3,nv]);
if cnt~=3*nv
    warning('Problem in reading vertices.');
end
X = X';

HalfElist=[];
Halfe2t=[];
ShowFaces=zeros(nf,20);

for i=1:nf
    CurrSize = fscanf(fid,'%d', 1);
    %SumSize=SumSize+CurrSize;
    CurrLine = fscanf(fid,'%d',CurrSize);
    ShowFaces(i,1:CurrSize+1)=[CurrSize CurrLine'];
    %ShowFaces(i,2:CurrSize+1)=CurrLine;
    ShowFaces(i,CurrSize+2:end)=CurrLine(end);
    HalfElist=[HalfElist;CurrLine(1:end-1) CurrLine(2:end);CurrLine(end) CurrLine(1)];
    Halfe2t=[Halfe2t;repmat(i, CurrSize,1) (1:CurrSize)'];
end

%Elist=[];
%e2t=[];
%InnerEdges=[];
%return;

if (~isempty(find(HalfElist==0)))  %zero-based index
    HalfElist=HalfElist+1;
   ShowFaces(:,2:end)=ShowFaces(:,2:end)+1;
end

PureAdj=sparse(HalfElist(:,1), HalfElist(:,2), ones(length(HalfElist),1), nv,nv);
FaceAdj=sparse(HalfElist(:,1), HalfElist(:,2), Halfe2t(:,1), nv,nv);
InFaceAdj=sparse(HalfElist(:,1), HalfElist(:,2), Halfe2t(:,2), nv,nv);
PureAdj=PureAdj+PureAdj';
[I,J,S]=find(triu(PureAdj)==2);  %inner edges
Elist=[I J];
e2t=[FaceAdj(sub2ind(size(FaceAdj),I,J)) InFaceAdj(sub2ind(size(FaceAdj),I,J)) FaceAdj(sub2ind(size(FaceAdj),J,I)) InFaceAdj(sub2ind(size(FaceAdj),J,I))];
InnerEdges=1:length(Elist);
[I,J,S]=find(PureAdj==1); %boundary edges
Elist=[Elist;I J];
e2t=[e2t;FaceAdj(sub2ind(size(FaceAdj),I,J))+FaceAdj(sub2ind(size(FaceAdj),J,I)) InFaceAdj(sub2ind(size(FaceAdj),I,J))+InFaceAdj(sub2ind(size(FaceAdj),J,I)) zeros(length(I),2)];
e2t=full(e2t);

t2e=zeros(size(ShowFaces,1), size(ShowFaces,2));
t2e(sub2ind(size(t2e),e2t(:,1),e2t(:,2)))=(1:length(Elist))';
t2e(sub2ind(size(t2e),e2t(InnerEdges,3),e2t(InnerEdges,4)))=-InnerEdges;
















    


fclose(fid);