clear all
close all
clc;

addpath('..\ccsubdivisionmatlab');
addpath(genpath('..\..\data\60_base_meshes_library\quads\animals'));
mname = 'horse';
% mname = 'bob_quad';

tic
m = MESHQ(mname);
toc
figure; MESH_VIS.mesh(m);

% subdivide
for i = 1:2
    
    % subdivision CC
    tic;
    fprintf('Subdivision, nv = %d, ', m.nv);
    [VertexPoints, EdgePoints, Elist, e2t, t2e, FacePoints]=GetCCPoints(m.vertices,double(m.quads));
    toc;
    
    % arrange new vertices
    subdivision_vertices =[VertexPoints;EdgePoints;FacePoints];
    
    % arrange new quads
    subdivision_quads = [m.quads(:,1) m.nv+abs(t2e(:,1)) m.nv+m.ne+(1:m.nf)' m.nv+abs(t2e(:,4));...
        m.quads(:,2) m.nv+abs(t2e(:,2)) m.nv+m.ne+(1:m.nf)' m.nv+abs(t2e(:,1));...
        m.quads(:,3) m.nv+abs(t2e(:,3)) m.nv+m.ne+(1:m.nf)' m.nv+abs(t2e(:,2));...
        m.quads(:,4) m.nv+abs(t2e(:,4)) m.nv+m.ne+(1:m.nf)' m.nv+abs(t2e(:,3))];
    tic;
    fprintf('MESHQ, nv = %d, ', size(subdivision_vertices,1));
    m = MESHQ(subdivision_vertices, subdivision_quads);
    toc;
    figure; MESH_VIS.mesh(m);

end



% MESH_VIS.vf(m, m.fva);
% MESH_VIS.vf(m, m.Ep1,'color','k')
% MESH_VIS.vf(m, m.Ep2,'color','w')


[vv,dd] = eigs(m.W, m.M0, 300, -1e-5);
figure; plot(diag(dd),'.');
for i=1:5
    figure;
    MESH_VIS.func(m, vv(:,i));
end