function wks = WKS(lbo_vecs, e_vec, sigma, log_eigenvals) % compute WKS
% WKS  Computing the Wave Kernel Signature for the shape

% compute exponential weights per energy
exponential_coefs_matrix = exp(-(e_vec - log_eigenvals).^2/(2*sigma.^2));

% normalization factors per energy (using broadcast - row vector minus column vector)
Ce = sum(exponential_coefs_matrix).^-1;

% compute the WKS
wks = lbo_vecs.^2*(exponential_coefs_matrix.*Ce);

end