function F = WK_descriptors(eigenfunctions, eigenvalues, basis_pinv, M0, num_energies, num_eigs, landmarks, flag_landmarks, S_to_fine)
% create the log eigens vector
log_eigenvals = [-inf; log(eigenvalues(2:num_eigs))];

% energies for wave kernel signature
delta = (log_eigenvals(end) - log_eigenvals(2))/num_energies;
sigma = 7*delta;
e_min = log_eigenvals(2)   + sigma;
e_max = log_eigenvals(end) - sigma;
%     e_min = log_eigenvals(2);
%     e_max = log_eigenvals(end);
e_vec = linspace(e_min, e_max, num_energies);

% compute the descriptors
wks = WKS(eigenfunctions, e_vec, sigma, log_eigenvals);
%     wkm = WKM(eigenfunctions_prolongation, e_vec, sigma, log_eigenvals, landmarks);
wkm_F = WKM_fast(eigenfunctions, e_vec, sigma, log_eigenvals, landmarks, flag_landmarks, S_to_fine); % output is coefficients

% normalization
wks = wks ./ repmat(sqrt(diag(wks'*M0*wks))', [size(eigenfunctions,1),1]);
%     wkm = cellfun(@(x) x./ repmat(sqrt(diag(x'*M0*x))', [size(eigenfunctions,1),1]), wkm, 'UniformOutput', false);
wkm_F = cellfun(@(x) normc(x) ,wkm_F, 'UniformOutput', false);

% convert to functional representation
wks_F = basis_pinv*wks;
%     wkm_F = cellfun(@(x) basis_pinv*x, wkm, 'UniformOutput', false);

% prepare outputs in cell array
F = cell(1,numel(landmarks)+1);
for i = 1:numel(landmarks) + 1
    if i == 1 % wks
        F{i} = wks_F;
    else % wkm
        F{i} = wkm_F{i-1};
    end
end

end