function X = commuting_descriptors(eigenfunctions, basis_pinv, F, num_commuting)

% compute the descriptors inds
num_energies = size(F{1},2);
descriptors_inds = floor(linspace(1, num_energies, num_commuting));

% take only a subset of descriptors
F_subset = cell2mat(cellfun(@(x) x(:, descriptors_inds), F, 'UniformOutput', false));

% compute descriptors from their cofficients
f = eigenfunctions*F_subset;

% compute functional multiplication operator
X = cell(1, size(f,2));
for i = 1:size(f,2)
    X{i} = basis_pinv * (f(:,i) .* eigenfunctions); % using broadcasting, faster than X_cell{i} = basis_pinv * diag(f(:,i)) * basis_M.eigenfunctions;
end

end