function [C,knn_matches] = icp_refine_coarse(C ,b1, b2)
% compute ICP subdivision refinement
% inputs:
%   1. C [k1 x k2]  - functional map to refine
%   3. b1 [n1 x k1] - basis for shape 1
%   4. b2 [n2 x k2] - basis for shape 2

% Iterate to refine
disp('Perform ICP postprocessing to the functional map');
for i = 1:5
    
    % find matches
    knn_matches = knnsearch((C*b2')', b1);
    % compute SVD to return orthonormal C
    W = (b2(knn_matches, :) \ b1)';
    [U, ~, V] = svd(W);
    C = U*eye(size(C))*V';
    
end

K = 3;
[knn_matches, ~] = knnsearch((C*b2')', b1, 'K', K);
% figure; imagesc(C); colormap(bluewhitered); colorbar;

end

