function [P_12, P_12_p2p, shape_2_post_shape] = post_process_subdivision_knn(knn_matches, C_12, basis_1_eigenfunctions_prol, basis_2_eigenfunctions_prol, shape_2)

disp('Perfrom post-process subdivision ICP step');

nv_1 = size(basis_1_eigenfunctions_prol,1);

% get subdivision matrix of the next level
disp('subdivide');
[shape_2_post_shape, S_0_fine_2] = shape_2.subdivideMesh;

% compute shape 2 even vertices 2-ring (current) inds
shape_2_even_vert_2_ring_inds = cell(1, size(S_0_fine_2,2));
for i = 1:size(S_0_fine_2,2)
    shape_2_even_vert_2_ring_inds{i} = find(S_0_fine_2(:,i));
end

% compute the indices to search for each vertex in shape1
shape_2_even_vert_2_ring_inds_to_search = {shape_2_even_vert_2_ring_inds{knn_matches(:,1)}};

% set points for knn search
points_1 = basis_1_eigenfunctions_prol';
rotated_points_2 = C_12*(S_0_fine_2*basis_2_eigenfunctions_prol)';

% compute knn matches
disp('knnsearch');
knn_matches = zeros(nv_1, 1);
parfor j = 1:nv_1
    inds_to_search = shape_2_even_vert_2_ring_inds_to_search{j};
    rotated_points_2_to_search = rotated_points_2(:, inds_to_search);
    ind_closet = knnsearch(rotated_points_2_to_search', points_1(:, j)', 'K', 1);
    knn_matches(j) = inds_to_search(ind_closet);
end

% build P_12 = P_1_fine_2_finer*S_0_2_fine, P_12 is still row
% sthocastic
P_12_p2p = sparse(1:nv_1, knn_matches, 1, nv_1, size(S_0_fine_2, 1));
P_12 = P_12_p2p*S_0_fine_2;
end
