function transfer_deformation(f_2_deformed, shape_2, shape_1, P_12)

% create the deformations for shape_2 (source) and shape_1 (target)
shape_2_deformed = MESHQ(shape_2.vertices + shape_2.vn .* f_2_deformed,      shape_2.quads);
shape_1_deformed = MESHQ(shape_1.vertices + shape_1.vn .* (P_12* f_2_deformed), shape_1.quads);

% visualize shapes and their deformation
figure; MESH_VIS.mesh(shape_2); title('Shape 2 - source');
figure; MESH_VIS.mesh(shape_2_deformed); title('Shape 2 - original deformation');
figure; MESH_VIS.mesh(shape_1); title('Shape 1 - target');
figure; MESH_VIS.mesh(shape_1_deformed); title('Shape 1 - transfered deformation');

end
