function transfer_func(ind, hierarchy_level, basis_1_hierarchy, basis_1_eigenfunctions_prol, basis_2_hierarchy, basis_2_eigenfunctions_prol, C_12, P_12, flag_type)
% Transfer high-res random function from shape2 to shape1


% create function to transfer
f_2 = zeros(basis_2_hierarchy{hierarchy_level}.shape.nv,1);
X = basis_2_hierarchy{hierarchy_level}.shape.vertices;
a0 = 3000; % STD for the src
for i = 1:numel(ind)
    dist0 = sqrt(sum(bsxfun(@minus,X,X(ind(i),:)).^2,2));
    f_2 = f_2 + exp(-dist0.^2*a0);
end

% f_2 = basis_2_eigenfunctions_prol(:, 30);

% f_2 = load('.\tests\func_demorf_woman_lowpoly_Apose_sbd_3_mapped.mat');

% get f freq coefficients
f_2_freq = basis_2_eigenfunctions_prol' * (basis_2_hierarchy{hierarchy_level}.A * f_2);
f_2_repr = basis_2_eigenfunctions_prol * f_2_freq;

% transfer funciton freq coefficients
f_1_freq = C_12 * f_2_freq;

% get transfered function
f_1_trans = basis_1_eigenfunctions_prol * f_1_freq;

% transfer function using P_12
f_1_trans_P_12 = P_12*f_2;

% visualize functions
if flag_type == 7 % quads
    if size(basis_1_eigenfunctions_prol,1) < 500000
        Results.EdgeColor = 'k';
    else
        Results.EdgeColor = 'none';
    end
    %     figure; MESH_VIS.func(basis_2_hierarchy{hierarchy_level}.shape, f_2, Results); colorbar; title(['f_2, n_v = ', num2str(numel(f_2))]);
    %     figure; MESH_VIS.func(basis_2_hierarchy{hierarchy_level}.shape, f_2_repr, Results); colorbar; title(['f_2 representation, #eigs = ' num2str(size(C_12,2))]);
    %     figure; MESH_VIS.func(basis_1_hierarchy{hierarchy_level}.shape, f_1_trans, Results); colorbar; title(['f_1 transfered with C size ', num2str(size(C_12,1)), ' x ', num2str(size(C_12,2))]);
    figure; MESH_VIS.func(basis_1_hierarchy{hierarchy_level}.shape, f_1_trans_P_12, Results); colorbar; title('f_1 transfered with P_{12}');
else % triagnles
    figure;
    subplot(2,2,1); basis_2_hierarchy{hierarchy_level}.shape.functionVis(f_2, 'v'); colorbar; title(['f_2, n_v = ', num2str(numel(f_2))]);
    subplot(2,2,2); basis_2_hierarchy{hierarchy_level}.shape.functionVis(f_2_repr, 'v'); colorbar; title(['f_2 representation, #eigs = ' num2str(size(C_12,2))]);
    subplot(2,2,3); basis_1_hierarchy{hierarchy_level}.shape.functionVis(f_1_trans, 'v'); colorbar; title(['f_1 transfered with C size ', num2str(size(C_12,1)), ' x ', num2str(size(C_12,2))]);
    subplot(2,2,4); basis_1_hierarchy{hierarchy_level}.shape.functionVis(f_1_trans_P_12, 'v'); colorbar; title('f_1 transfered with P_{12}');
    
end

end
